<!DOCTYPE html>
<html lang="en">
<head>
  <title>List users</title>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>

  <!-- Import Datatable sau jquery -->
  <!-- Import them style bootstrap cho datatable -->
  <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
  <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
  <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>


</head>
<body>

<div class="container">
  <div class="text-center mt-4 mb-3">
    <h2>Danh sách người dùng</h2>
  </div>
  
  <table id="user-table" class="table table-bordered table-striped table-hover">
    <thead>
      <tr>
        <td>STT</td>
        <td>Username</td>
        <td>First name</td>
        <td>Last name</td>
        <td>Email</td>
        <td>Age</td>
        <td>Role</td>
        <td>Action</td>
      </tr>
    </thead>
    <tbody>
      
    </tbody>
  </table>
</div>
​<script>
  /***
    * TODO: gán data user vào DataTale, render cột STT và mapping được roleId thành roleName
    
    *** Gợi ý cho cột STT ***
    * a) sử dụng phương thức render trong cột STT (định nghĩa ở columnDefs); 
    * b) khai báo 1 biến toàn cục STT và mỗi lần render thì tăng lên 1
    
    * *** Gợi ý cho cột role ***
    * a) sử dụng phương thức render trong cột Role (định nghĩa ở columnDefs); 
    * b) khai báo 1 hàm từ roleId trả về roleName, và đc gọi hàm này trong phương thức render ở trên
  */

  $(document).ready(function() {
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    var gJsonUser = `{
      "description": "Data user",
      "users": [
      {
        "id": 2,
        "username": "quannv",
        "firstname": "Ngo Van",
        "lastname": "Quan",
        "age": 18,
        "email": "quan@gmail.com",
        "roleId": 5
      },
      {
        "id": 3,
        "username": "longdh",
        "firstname": "Do Hoang",
        "lastname": "Long",
        "age": 19,
        "email": "long@gmail.com",
        "roleId": 8
      },
      {
        "id": 4,
        "username": "hiendt",
        "firstname": "Do Thi",
        "lastname": "Hien",
        "age": 29,
        "email": "hien@gmail.com",
        "roleId": 11
      },
      {
        "id": 6,
        "username": "lanht",
        "firstname": "Ho Thi",
        "lastname": "Lan",
        "age": 27,
        "email": "lan@gmail.com",
        "roleId": 13
      }
    ]
  }`;
    var gJsonRole = `{
      "description": "User Roles",
      "roles": [
        {
          "roleId": 5,
          "roleName": "Admin" 
        },
        {
          "roleId": 8,
          "roleName": "Manager" 
        },
        {
          "roleId": 11,
          "roleName": "Teacher" 
        },
        {
          "roleId": 13,
          "roleName": "Staff" 
        }
      ]
    }`;
    
    var gUserObj = JSON.parse(gJsonUser);
    console.log(gUserObj);
    var gRoleObj = JSON.parse(gJsonRole);
    console.log(gRoleObj);

    const gUSER_LIST = ['stt', 'username', 'firstname', 'lastname', 'email', 'age', 'roleId','action'];
    const gSTT_COL = 0;
    const gUSER_NAME_COL = 1;
    const gFIRST_NAME_COL = 2;
    const gLAST_NAME_COL = 3;
    const gEMAIL_COL = 4;
    const gAGE_COL = 5;
    const gROLE_ID_COL = 6;
    const gACTION_COL = 7;

    var vSTT = 0;

    /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
    
    onPageLoading();

    $(document).on("click", "#user-table .btn-detail", function(){   
      onBtnDetailClick(this);
    });

    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    
    function onPageLoading(){
    
      $("#user-table").DataTable({ 
        data: gUserObj.users,
        columns: [
            {data: gUSER_LIST[gSTT_COL]},
            {data: gUSER_LIST[gUSER_NAME_COL]},
            {data: gUSER_LIST[gFIRST_NAME_COL]},
            {data: gUSER_LIST[gLAST_NAME_COL]},
            {data: gUSER_LIST[gEMAIL_COL]},
            {data: gUSER_LIST[gAGE_COL]},
            {data: gUSER_LIST[gROLE_ID_COL]},
            {data: gUSER_LIST[gACTION_COL]},
        ],
        columnDefs: [
            {
              targets: gSTT_COL,
              className: "text-center text-primary",
              render: renderSTT
            },  
            {
              targets: gROLE_ID_COL,
              className: "text-center text-primary",
              render: transferRoleIdToRoleName
            },
            {
                targets: gACTION_COL,
                defaultContent: "<button class='btn btn-info btn-detail'> Detail </button>"
            },
        ]
      });
    };

    //function on transferring Role-ID to Role-Name
    function transferRoleIdToRoleName (paramRoleId){
      var vRoleName = "";
      var vFound = false;
      var index = 0;
      while (!vFound && index < gRoleObj.roles.length){
        if (gRoleObj.roles[index].roleId === paramRoleId){
          vRoleName = gRoleObj.roles[index].roleName;
          vFound = true;
        }
        index++;
      }
      return vRoleName;
    };

  /*  function transferRoleIdToRoleName(paramData, paramType, paramRow){
      var vName = "";
      console.log(paramData);
      console.log(paramRow);
      console.log("Type: " + paramType);

      if (paramData == 5){
        vName = "Admin";
      }
      else if (paramData == 8){  
        vName = "Manager";
      }
      else if (paramData == 11){  
        vName = "Teacher";
      }
      else if (paramData == 13){  
        vName = "Staff";
      }
      return vName;
    }
  */
 
  

    //function for vSTT
    function renderSTT(){
      vSTT++;
      return vSTT;
    }
    
    //function for Detail Button
    function onBtnDetailClick(paramElement){
      "use strict";
      var vRowClick = $(paramElement).closest("tr");
      var vTable = $('#user-table').DataTable(); 
      var vDataRow = vTable.row( vRowClick ).data(); 
      console.log(vDataRow);
    }
    
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/

  });
  
</script>
</body>
</html>